﻿#region License Information
/* HeuristicLab
 * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Reflection;
using HEAL.Attic;

namespace HeuristicLab.Persistence.Default.Xml.Primitive {

  internal abstract class SimpleNumber2XmlSerializerBase<T> : PrimitiveXmlSerializerBase<T> {

    private static MethodInfo ParseMethod = typeof(T)
      .GetMethod(
        "Parse",
        BindingFlags.Static | BindingFlags.Public,
        null,
        CallingConventions.Standard,
        new[] { typeof(string) },
        null);

    public override XmlString Format(T t) {
      return new XmlString(t.ToString());
    }

    public override T Parse(XmlString x) {
      try {
        return (T)ParseMethod.Invoke(null, new[] { x.Data });
      }
      catch (Exception e) {
        throw new PersistenceException("Could not parse simple number.", e);
      }
    }
  }
}